//
//  クイックソート
//
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#define N 30

void quicksort(int *, int, int);


int main(int argc, char **argv)
{
    int x[N];  //  ソートすべきデータ
    int i;     //  ループ用


    srandom(time(NULL));

    for (i = 0 ; i < N ; i++)
    {
        x[i] = random() % 1000;
    }

    printf("--- 整列前 ---\n");
    for (i = 0 ; i < N ; i++)
    {
        printf("%4d", x[i]);
    }
    printf("\n");

    quicksort(x, 0, N - 1);

    printf("--- 整列後 ---\n");
    for (i = 0 ; i < N ; i++)
    {
        printf("%4d", x[i]);
    }
    printf("\n");

    return(0);
}


//
//  2つの整数変数を入れ替える
//
void swap(int *a, int *b)
{
    int t;


    t = *a;
    *a = *b;
    *b = t;
}


//
//  クイックソートによるソートルーチン
//  x[]  : データ本体
//  first: 先頭データのインデックス(0, ..., N-1)
//  last : 末尾データのインデックス(0, ..., N-1)
//
void quicksort(int *x, int first, int last)
{
    int m;     //  ピボットの値
    int a, b;  //
    int idx;   //
    int i;     //  ループ用


    idx = (last - first) / 2 + first;
    m = *(x + idx);  //  x[first] ... x[last] の中間のx[m]の値を拾い出す

    printf("\npivot = %3d\n", m);
    printf("[ ");
    for (i = first ; i <= last ; i++) printf("%3d ", x[i]);
    printf("] --> ");

    a = first;
    b = last;

    while(a <= b)  //  交差するまで繰り返す
    {
        while ((a < last) && (*(x + a)< m )) a++;    //  左から調べてmより大きいデータが見つかるまでカーソルを移動する
        while ((b > first) && (*(x + b) > m)) b--;   //  右から調べてmより小さいデータが見つかるまでカーソルを移動する
        if (a > b) break;
        swap(x + a, x + b);
        a++;
        b--;
    }

    printf("[ ");
    for (i = first ; i < a ; i++) printf("%3d ", x[i]);
    printf("]  [ ");
    for (i = a ; i <= last ; i++) printf("%3d ", x[i]);
    printf("]\n");

    if (first < a - 1) quicksort(x, first, a - 1);
    if (a < last) quicksort(x, a, last);
}
